Merge branch 'mm/log-format-raw-doc' into maint
[git.git] / git-stash.sh
blobcc28368b01fc218f32ae98c21cce4d7f84c68eb0
1 #!/bin/sh
2 # Copyright (c) 2007, Nanako Shiraishi
4 dashless=$(basename "$0" | sed -e 's/-/ /')
5 USAGE="list [<options>]
6 or: $dashless show [<stash>]
7 or: $dashless drop [-q|--quiet] [<stash>]
8 or: $dashless ( pop | apply ) [--index] [-q|--quiet] [<stash>]
9 or: $dashless branch <branchname> [<stash>]
10 or: $dashless [save [--patch] [-k|--[no-]keep-index] [-q|--quiet]
11 [-u|--include-untracked] [-a|--all] [<message>]]
12 or: $dashless clear"
14 SUBDIRECTORY_OK=Yes
15 OPTIONS_SPEC=
16 START_DIR=$(pwd)
17 . git-sh-setup
18 . git-sh-i18n
19 require_work_tree
20 cd_to_toplevel
22 TMP="$GIT_DIR/.git-stash.$$"
23 TMPindex=${GIT_INDEX_FILE-"$GIT_DIR/index"}.stash.$$
24 trap 'rm -f "$TMP-"* "$TMPindex"' 0
26 ref_stash=refs/stash
28 if git config --get-colorbool color.interactive; then
29 help_color="$(git config --get-color color.interactive.help 'red bold')"
30 reset_color="$(git config --get-color '' reset)"
31 else
32 help_color=
33 reset_color=
36 no_changes () {
37 git diff-index --quiet --cached HEAD --ignore-submodules -- &&
38 git diff-files --quiet --ignore-submodules &&
39 (test -z "$untracked" || test -z "$(untracked_files)")
42 untracked_files () {
43 excl_opt=--exclude-standard
44 test "$untracked" = "all" && excl_opt=
45 git ls-files -o -z $excl_opt
48 clear_stash () {
49 if test $# != 0
50 then
51 die "$(gettext "git stash clear with parameters is unimplemented")"
53 if current=$(git rev-parse --verify --quiet $ref_stash)
54 then
55 git update-ref -d $ref_stash $current
59 create_stash () {
60 stash_msg="$1"
61 untracked="$2"
63 git update-index -q --refresh
64 if no_changes
65 then
66 exit 0
69 # state of the base commit
70 if b_commit=$(git rev-parse --verify HEAD)
71 then
72 head=$(git rev-list --oneline -n 1 HEAD --)
73 else
74 die "$(gettext "You do not have the initial commit yet")"
77 if branch=$(git symbolic-ref -q HEAD)
78 then
79 branch=${branch#refs/heads/}
80 else
81 branch='(no branch)'
83 msg=$(printf '%s: %s' "$branch" "$head")
85 # state of the index
86 i_tree=$(git write-tree) &&
87 i_commit=$(printf 'index on %s\n' "$msg" |
88 git commit-tree $i_tree -p $b_commit) ||
89 die "$(gettext "Cannot save the current index state")"
91 if test -n "$untracked"
92 then
93 # Untracked files are stored by themselves in a parentless commit, for
94 # ease of unpacking later.
95 u_commit=$(
96 untracked_files | (
97 GIT_INDEX_FILE="$TMPindex" &&
98 export GIT_INDEX_FILE &&
99 rm -f "$TMPindex" &&
100 git update-index -z --add --remove --stdin &&
101 u_tree=$(git write-tree) &&
102 printf 'untracked files on %s\n' "$msg" | git commit-tree $u_tree &&
103 rm -f "$TMPindex"
104 ) ) || die "Cannot save the untracked files"
106 untracked_commit_option="-p $u_commit";
107 else
108 untracked_commit_option=
111 if test -z "$patch_mode"
112 then
114 # state of the working tree
115 w_tree=$( (
116 git read-tree --index-output="$TMPindex" -m $i_tree &&
117 GIT_INDEX_FILE="$TMPindex" &&
118 export GIT_INDEX_FILE &&
119 git diff --name-only -z HEAD -- >"$TMP-stagenames" &&
120 git update-index -z --add --remove --stdin <"$TMP-stagenames" &&
121 git write-tree &&
122 rm -f "$TMPindex"
123 ) ) ||
124 die "$(gettext "Cannot save the current worktree state")"
126 else
128 rm -f "$TMP-index" &&
129 GIT_INDEX_FILE="$TMP-index" git read-tree HEAD &&
131 # find out what the user wants
132 GIT_INDEX_FILE="$TMP-index" \
133 git add--interactive --patch=stash -- &&
135 # state of the working tree
136 w_tree=$(GIT_INDEX_FILE="$TMP-index" git write-tree) ||
137 die "$(gettext "Cannot save the current worktree state")"
139 git diff-tree -p HEAD $w_tree -- >"$TMP-patch" &&
140 test -s "$TMP-patch" ||
141 die "$(gettext "No changes selected")"
143 rm -f "$TMP-index" ||
144 die "$(gettext "Cannot remove temporary index (can't happen)")"
148 # create the stash
149 if test -z "$stash_msg"
150 then
151 stash_msg=$(printf 'WIP on %s' "$msg")
152 else
153 stash_msg=$(printf 'On %s: %s' "$branch" "$stash_msg")
155 w_commit=$(printf '%s\n' "$stash_msg" |
156 git commit-tree $w_tree -p $b_commit -p $i_commit $untracked_commit_option) ||
157 die "$(gettext "Cannot record working tree state")"
160 store_stash () {
161 while test $# != 0
163 case "$1" in
164 -m|--message)
165 shift
166 stash_msg="$1"
168 -q|--quiet)
169 quiet=t
172 break
174 esac
175 shift
176 done
177 test $# = 1 ||
178 die "$(eval_gettext "\"$dashless store\" requires one <commit> argument")"
180 w_commit="$1"
181 if test -z "$stash_msg"
182 then
183 stash_msg="Created via \"git stash store\"."
186 # Make sure the reflog for stash is kept.
187 : >>"$GIT_DIR/logs/$ref_stash"
188 git update-ref -m "$stash_msg" $ref_stash $w_commit
189 ret=$?
190 test $ret != 0 && test -z $quiet &&
191 die "$(eval_gettext "Cannot update \$ref_stash with \$w_commit")"
192 return $ret
195 save_stash () {
196 keep_index=
197 patch_mode=
198 untracked=
199 while test $# != 0
201 case "$1" in
202 -k|--keep-index)
203 keep_index=t
205 --no-keep-index)
206 keep_index=n
208 -p|--patch)
209 patch_mode=t
210 # only default to keep if we don't already have an override
211 test -z "$keep_index" && keep_index=t
213 -q|--quiet)
214 GIT_QUIET=t
216 -u|--include-untracked)
217 untracked=untracked
219 -a|--all)
220 untracked=all
223 shift
224 break
227 option="$1"
228 # TRANSLATORS: $option is an invalid option, like
229 # `--blah-blah'. The 7 spaces at the beginning of the
230 # second line correspond to "error: ". So you should line
231 # up the second line with however many characters the
232 # translation of "error: " takes in your language. E.g. in
233 # English this is:
235 # $ git stash save --blah-blah 2>&1 | head -n 2
236 # error: unknown option for 'stash save': --blah-blah
237 # To provide a message, use git stash save -- '--blah-blah'
238 eval_gettextln "error: unknown option for 'stash save': \$option
239 To provide a message, use git stash save -- '\$option'"
240 usage
243 break
245 esac
246 shift
247 done
249 if test -n "$patch_mode" && test -n "$untracked"
250 then
251 die "Can't use --patch and --include-untracked or --all at the same time"
254 stash_msg="$*"
256 git update-index -q --refresh
257 if no_changes
258 then
259 say "$(gettext "No local changes to save")"
260 exit 0
262 test -f "$GIT_DIR/logs/$ref_stash" ||
263 clear_stash || die "$(gettext "Cannot initialize stash")"
265 create_stash "$stash_msg" $untracked
266 store_stash -m "$stash_msg" -q $w_commit ||
267 die "$(gettext "Cannot save the current status")"
268 say Saved working directory and index state "$stash_msg"
270 if test -z "$patch_mode"
271 then
272 git reset --hard ${GIT_QUIET:+-q}
273 test "$untracked" = "all" && CLEAN_X_OPTION=-x || CLEAN_X_OPTION=
274 if test -n "$untracked"
275 then
276 git clean --force --quiet -d $CLEAN_X_OPTION
279 if test "$keep_index" = "t" && test -n $i_tree
280 then
281 git read-tree --reset -u $i_tree
283 else
284 git apply -R < "$TMP-patch" ||
285 die "$(gettext "Cannot remove worktree changes")"
287 if test "$keep_index" != "t"
288 then
289 git reset
294 have_stash () {
295 git rev-parse --verify --quiet $ref_stash >/dev/null
298 list_stash () {
299 have_stash || return 0
300 git log --format="%gd: %gs" -g --first-parent -m "$@" $ref_stash --
303 show_stash () {
304 assert_stash_like "$@"
306 git diff ${FLAGS:---stat} $b_commit $w_commit
310 # Parses the remaining options looking for flags and
311 # at most one revision defaulting to ${ref_stash}@{0}
312 # if none found.
314 # Derives related tree and commit objects from the
315 # revision, if one is found.
317 # stash records the work tree, and is a merge between the
318 # base commit (first parent) and the index tree (second parent).
320 # REV is set to the symbolic version of the specified stash-like commit
321 # IS_STASH_LIKE is non-blank if ${REV} looks like a stash
322 # IS_STASH_REF is non-blank if the ${REV} looks like a stash ref
323 # s is set to the SHA1 of the stash commit
324 # w_commit is set to the commit containing the working tree
325 # b_commit is set to the base commit
326 # i_commit is set to the commit containing the index tree
327 # u_commit is set to the commit containing the untracked files tree
328 # w_tree is set to the working tree
329 # b_tree is set to the base tree
330 # i_tree is set to the index tree
331 # u_tree is set to the untracked files tree
333 # GIT_QUIET is set to t if -q is specified
334 # INDEX_OPTION is set to --index if --index is specified.
335 # FLAGS is set to the remaining flags
337 # dies if:
338 # * too many revisions specified
339 # * no revision is specified and there is no stash stack
340 # * a revision is specified which cannot be resolve to a SHA1
341 # * a non-existent stash reference is specified
344 parse_flags_and_rev()
346 test "$PARSE_CACHE" = "$*" && return 0 # optimisation
347 PARSE_CACHE="$*"
349 IS_STASH_LIKE=
350 IS_STASH_REF=
351 INDEX_OPTION=
353 w_commit=
354 b_commit=
355 i_commit=
356 u_commit=
357 w_tree=
358 b_tree=
359 i_tree=
360 u_tree=
362 REV=$(git rev-parse --no-flags --symbolic --sq "$@") || exit 1
364 FLAGS=
365 for opt
367 case "$opt" in
368 -q|--quiet)
369 GIT_QUIET=-t
371 --index)
372 INDEX_OPTION=--index
375 FLAGS="${FLAGS}${FLAGS:+ }$opt"
377 esac
378 done
380 eval set -- $REV
382 case $# in
384 have_stash || die "$(gettext "No stash found.")"
385 set -- ${ref_stash}@{0}
391 die "$(eval_gettext "Too many revisions specified: \$REV")"
393 esac
395 REV=$(git rev-parse --symbolic --verify --quiet "$1") || {
396 reference="$1"
397 die "$(eval_gettext "\$reference is not a valid reference")"
400 i_commit=$(git rev-parse --verify --quiet "$REV^2") &&
401 set -- $(git rev-parse "$REV" "$REV^1" "$REV:" "$REV^1:" "$REV^2:" 2>/dev/null) &&
402 s=$1 &&
403 w_commit=$1 &&
404 b_commit=$2 &&
405 w_tree=$3 &&
406 b_tree=$4 &&
407 i_tree=$5 &&
408 IS_STASH_LIKE=t &&
409 test "$ref_stash" = "$(git rev-parse --symbolic-full-name "${REV%@*}")" &&
410 IS_STASH_REF=t
412 u_commit=$(git rev-parse --verify --quiet "$REV^3") &&
413 u_tree=$(git rev-parse "$REV^3:" 2>/dev/null)
416 is_stash_like()
418 parse_flags_and_rev "$@"
419 test -n "$IS_STASH_LIKE"
422 assert_stash_like() {
423 is_stash_like "$@" || {
424 args="$*"
425 die "$(eval_gettext "'\$args' is not a stash-like commit")"
429 is_stash_ref() {
430 is_stash_like "$@" && test -n "$IS_STASH_REF"
433 assert_stash_ref() {
434 is_stash_ref "$@" || {
435 args="$*"
436 die "$(eval_gettext "'\$args' is not a stash reference")"
440 apply_stash () {
442 assert_stash_like "$@"
444 git update-index -q --refresh || die "$(gettext "unable to refresh index")"
445 git diff-index --cached --quiet --ignore-submodules HEAD -- ||
446 die "$(gettext "Cannot apply stash: Your index contains uncommitted changes.")"
448 # current index state
449 c_tree=$(git write-tree) ||
450 die "$(gettext "Cannot apply a stash in the middle of a merge")"
452 unstashed_index_tree=
453 if test -n "$INDEX_OPTION" && test "$b_tree" != "$i_tree" &&
454 test "$c_tree" != "$i_tree"
455 then
456 git diff-tree --binary $s^2^..$s^2 | git apply --cached
457 test $? -ne 0 &&
458 die "$(gettext "Conflicts in index. Try without --index.")"
459 unstashed_index_tree=$(git write-tree) ||
460 die "$(gettext "Could not save index tree")"
461 git reset
464 if test -n "$u_tree"
465 then
466 GIT_INDEX_FILE="$TMPindex" git-read-tree "$u_tree" &&
467 GIT_INDEX_FILE="$TMPindex" git checkout-index --all &&
468 rm -f "$TMPindex" ||
469 die 'Could not restore untracked files from stash'
472 eval "
473 GITHEAD_$w_tree='Stashed changes' &&
474 GITHEAD_$c_tree='Updated upstream' &&
475 GITHEAD_$b_tree='Version stash was based on' &&
476 export GITHEAD_$w_tree GITHEAD_$c_tree GITHEAD_$b_tree
479 if test -n "$GIT_QUIET"
480 then
481 GIT_MERGE_VERBOSITY=0 && export GIT_MERGE_VERBOSITY
483 if git merge-recursive $b_tree -- $c_tree $w_tree
484 then
485 # No conflict
486 if test -n "$unstashed_index_tree"
487 then
488 git read-tree "$unstashed_index_tree"
489 else
490 a="$TMP-added" &&
491 git diff-index --cached --name-only --diff-filter=A $c_tree >"$a" &&
492 git read-tree --reset $c_tree &&
493 git update-index --add --stdin <"$a" ||
494 die "$(gettext "Cannot unstage modified files")"
495 rm -f "$a"
497 squelch=
498 if test -n "$GIT_QUIET"
499 then
500 squelch='>/dev/null 2>&1'
502 (cd "$START_DIR" && eval "git status $squelch") || :
503 else
504 # Merge conflict; keep the exit status from merge-recursive
505 status=$?
506 git rerere
507 if test -n "$INDEX_OPTION"
508 then
509 gettextln "Index was not unstashed." >&2
511 exit $status
515 pop_stash() {
516 assert_stash_ref "$@"
518 if apply_stash "$@"
519 then
520 drop_stash "$@"
521 else
522 status=$?
523 say "The stash is kept in case you need it again."
524 exit $status
528 drop_stash () {
529 assert_stash_ref "$@"
531 git reflog delete --updateref --rewrite "${REV}" &&
532 say "$(eval_gettext "Dropped \${REV} (\$s)")" ||
533 die "$(eval_gettext "\${REV}: Could not drop stash entry")"
535 # clear_stash if we just dropped the last stash entry
536 git rev-parse --verify --quiet "$ref_stash@{0}" >/dev/null ||
537 clear_stash
540 apply_to_branch () {
541 test -n "$1" || die "$(gettext "No branch name specified")"
542 branch=$1
543 shift 1
545 set -- --index "$@"
546 assert_stash_like "$@"
548 git checkout -b $branch $REV^ &&
549 apply_stash "$@" && {
550 test -z "$IS_STASH_REF" || drop_stash "$@"
554 PARSE_CACHE='--not-parsed'
555 # The default command is "save" if nothing but options are given
556 seen_non_option=
557 for opt
559 case "$opt" in
560 -*) ;;
561 *) seen_non_option=t; break ;;
562 esac
563 done
565 test -n "$seen_non_option" || set "save" "$@"
567 # Main command set
568 case "$1" in
569 list)
570 shift
571 list_stash "$@"
573 show)
574 shift
575 show_stash "$@"
577 save)
578 shift
579 save_stash "$@"
581 apply)
582 shift
583 apply_stash "$@"
585 clear)
586 shift
587 clear_stash "$@"
589 create)
590 shift
591 create_stash "$*" && echo "$w_commit"
593 store)
594 shift
595 store_stash "$@"
597 drop)
598 shift
599 drop_stash "$@"
601 pop)
602 shift
603 pop_stash "$@"
605 branch)
606 shift
607 apply_to_branch "$@"
610 case $# in
612 save_stash &&
613 say "$(gettext "(To restore them type \"git stash apply\")")"
616 usage
617 esac
619 esac